import ImmutableFileDescriptor from './ImmutableFileDescriptor.js';
import { z }                   from 'zod';


const AssignmentFile = z.object({
                                    dojoAssignmentVersion: z.number(),
                                    version              : z.number(),
                                    immutable            : z.array(ImmutableFileDescriptor),
                                    result               : z.object({
                                                                        container: z.string(),
                                                                        volume   : z.string().optional()
                                                                    })
                                }).strict();


type AssignmentFile = z.infer<typeof AssignmentFile>;


export default AssignmentFile;